/*
 * 2004-10-23 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.util;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.ui.editors.text.TextEditor;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.vivianj.eclipse.plugin.buildfile.data.NodeData;

/**
 * BuildFileTreeITextEditorɶӦbuildfile
 */
public class BuildFileTree {
	private Tree tree = null;

	private Group group = null;

	private TextEditor editor = null;

	private Document document = null;

	/**
	 * BuildFileTree
	 *  
	 */
	public BuildFileTree() {

	}

	public Group getGroup() {
		return group;
	}

	public void setGroup(Group group) {
		this.group = group;
	}

	public TextEditor getTextEditor() {
		return editor;
	}

	public void setTextEditor(TextEditor editor) {
		this.editor = editor;
	}

	public Tree getTree() {
		return tree;
	}

	public void setTree(Tree tree) {
		this.tree = tree;
	}

	//	ݴ򿪵ļProjectDocument
	private void createDocument() {
		try {

			String editorText = editor.getDocumentProvider().getDocument(
					editor.getEditorInput()).get();
			InputStream in = new ByteArrayInputStream(editorText.getBytes());
			SAXBuilder builder = new SAXBuilder();
			document = builder.build(in);
		} catch (IOException ioe) {

		} catch (JDOMException ioe) {

		}
	}

	//Document
	public Tree createTree() {
		// Documentĵ
		this.createDocument();

		Element root = document.getRootElement();
		NodeData data = this.getNodeData(root, "project");

		tree = new Tree(this.group, SWT.SIMPLE);
		tree.setLayout(new GridLayout());
		tree.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL
				| GridData.GRAB_VERTICAL));

		TreeItem rootItem = new TreeItem(tree, SWT.SIMPLE, 0);
		rootItem.setText(data.getName());
		rootItem.setData(data);
		rootItem.setExpanded(true);
		
		tree.setTopItem(rootItem);
		

		//ProjectĽڵ
		this.createChildNodeOfProject(root, rootItem);

		return tree;
	}

	private void createChildNode(Element element, TreeItem father) {
		List children = element.getChildren();
		int count = children.size();
		for (int i = count; i > 0; i--) {
			Element childElement = (Element) children.get(i - 1);
			NodeData fatherData = (NodeData) father.getData();
			String path = fatherData.getPath() + "," + childElement.getName();

			NodeData data = this.getNodeData(childElement, path);

			TreeItem childItem = new TreeItem(father, SWT.SIMPLE, 0);
			childItem.setText(data.getName());
			childItem.setData(data);

			List list = childElement.getChildren();
			if (list.size() > 0) {
				createChildNode(childElement, childItem);
			}
		}
	}

	private void createChildNodeOfProject(Element element, TreeItem father) {
		List children = element.getChildren();
		int count = children.size();
		for (int i = count; i > 0; i--) {
			Element childElement = (Element) children.get(i - 1);
			String name = childElement.getName();
			if (!(name.toLowerCase().equals("property"))) {
				NodeData fatherData = (NodeData) father.getData();
				String path = fatherData.getPath() + ","
						+ childElement.getName();

				NodeData data = this.getNodeData(childElement, path);

				TreeItem childItem = new TreeItem(father, SWT.SIMPLE, 0);
				childItem.setText(data.getName());
				childItem.setData(data);

				List list = childElement.getChildren();
				if (list.size() > 0) {
					createChildNode(childElement, childItem);
				}
			}
		}

		children = element.getChildren("property");
		count = children.size();	
		
		for (int i = count; i > 0; i--) {
			Element childElement = (Element) children.get(i - 1);
			NodeData fatherData = (NodeData) father.getData();
			String path = fatherData.getPath() + "," + childElement.getName();

			NodeData data = this.getNodeData(childElement, path);

			TreeItem childItem = new TreeItem(father, SWT.SIMPLE, 0);
			childItem.setText(data.getName());
			childItem.setData(data);

			List list = childElement.getChildren();
			if (list.size() > 0) {
				createChildNode(childElement, childItem);
			}
		}
	}

	//	ָԪغļеpathҪڵЯ
	private NodeData getNodeData(Element element, String path) {

		String name = element.getAttributeValue("name");
		String elementName = element.getName();
		NodeData data = new NodeData(element);
		data.setName(name != null
				&& (elementName.equals("project")
						|| elementName.equals("target") || elementName
						.equals("property")) ? name : elementName);
		data.setElementName(elementName);
		data.setPath(path);
		return data;
	}

}