/*
 * 2004-10-24 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.util;

import java.util.Iterator;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.ui.editors.text.TextEditor;
import org.jdom.Element;
import org.vivianj.eclipse.plugin.buildfile.data.NodeData;
import org.vivianj.eclipse.plugin.buildfile.group.PropertyGroup;
import org.vivianj.eclipse.plugin.buildfile.group.RightGroup;

/**
 * ڵĹ
 */
public class ShellFactory {
	private NodeData NodeData = null;

	private Shell parent = null;

	private Group group = null;

	private TreeItem treeItem = null;

	private TextEditor editor = null;

	/**
	 * 
	 * ShellFactory
	 */
	public ShellFactory() {
	}

	public TextEditor getEditor() {
		return editor;
	}

	public void setEditor(TextEditor editor) {
		this.editor = editor;
	}

	public NodeData getNodeData() {
		return NodeData;
	}

	public void setNodeData(NodeData NodeData) {
		this.NodeData = NodeData;
	}

	public Group getGroup() {
		return group;
	}

	public void setGroup(Group group) {
		this.group = group;
	}

	public Shell getParent() {
		return parent;
	}

	public void setParent(Shell parent) {
		this.parent = parent;
	}

	public TreeItem getTreeItem() {
		return treeItem;
	}

	public void setTreeItem(TreeItem treeItem) {
		this.treeItem = treeItem;
	}

	/**
	 * 
	 * @param NodeData
	 *            ڵӦNodeData
	 * @param parent
	 *            paren
	 * @param group
	 *            ڵʾʵ
	 * @param treeItem
	 *            Ӧڵ
	 * @param editor
	 *            ITextEditorʵ
	 */
	public static void createShell(NodeData NodeData, Shell parent,
			Group group, TreeItem treeItem, TextEditor editor) {
		ShellFactory menuFactory = new ShellFactory();
		menuFactory.setNodeData(NodeData);
		menuFactory.setGroup(group);
		menuFactory.setParent(parent);
		menuFactory.setTreeItem(treeItem);
		menuFactory.setEditor(editor);

		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		parent.setLayout(gridLayout);

		NodeData data = (NodeData) treeItem.getData();
		String path = data.getPath();
		BuildFileTemplate builFile = new BuildFileTemplate();

		Element element = builFile.getElementByPath(path);
		
		menuFactory.createShell(element);
	}

	private void createShell(Element element) {
		
		List list = element.getChildren();
		if (list.size() > 0) {
			Iterator it = list.iterator();
			while (it.hasNext()) {
				String name = ((Element) it.next()).getName();
				this.createButton(name, parent, name);
			}
		}
	}

	private void createButton(String text, Shell parent, String key) {
		Button button = new Button(parent, SWT.RADIO);
		button.setLayoutData(new GridLayout());
		button.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL
				| GridData.VERTICAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		button.setText(text);
		button.addMouseListener(new ButtonMouseListener(this.NodeData,
				this.group, this.treeItem, this.parent, key, this.editor));
	}

	class ButtonMouseListener extends MouseAdapter {
		private Group group = null;

		private TreeItem treeItem = null;

		private NodeData NodeData = null;

		private Shell shell = null;

		private TextEditor editor = null;

		private String key = null;

		public ButtonMouseListener(NodeData NodeData, Group group,
				TreeItem treeItem, Shell shell, String key, TextEditor p_editor) {
			this.group = group;
			this.treeItem = treeItem;
			this.NodeData = NodeData;
			this.shell = shell;
			this.key = key;
			this.editor = p_editor;
		}

		public NodeData getNodeData() {
			return NodeData;
		}

		public void setNodeData(NodeData NodeData) {
			this.NodeData = NodeData;
		}

		public Group getGroup() {
			return group;
		}

		public void setGroup(Group group) {
			this.group = group;
		}

		public TreeItem getTreeItem() {
			return treeItem;
		}

		public void setTreeItem(TreeItem treeItem) {
			this.treeItem = treeItem;
		}

		public void mouseDown(MouseEvent event) {
			//µĽڵ
			TreeItem t_treeItem = new TreeItem(this.treeItem, SWT.SIMPLE);

			Button button = (Button) event.getSource();
			String elementName = button.getText().trim();

			NodeData data = (NodeData) this.treeItem.getData();
			String path = data.getPath();

			BuildFileTemplate buildFile = new BuildFileTemplate();
			String nodePath = path + "," + elementName;
			Element element = buildFile.getElementByPath(nodePath);
			NodeData nodeData = new NodeData(element);
			nodeData.setName(elementName);
			nodeData.setElementName(elementName);
			nodeData.setPath(nodePath);

			t_treeItem.setData(nodeData);
			t_treeItem.setText(nodeData.getName());
			t_treeItem.getParent().setSelection(new TreeItem[] { t_treeItem });

			//			еĿؼ
			ControlDispose.disposeControls(this.group);

			//µ
			this.createGroup(data, t_treeItem);

			shell.dispose();
		}

		private void createGroup(Object o, TreeItem p_treeItem) {
			//			µ
			RightGroup rightGroup = new PropertyGroup(this.group, p_treeItem);

			rightGroup.createPanel();
			rightGroup.setEditor(this.editor);
			
			rightGroup.invokeSave();
			
			//	      ˢ½
			this.redraw();
		}

		private void redraw() {
			this.group.layout();
			this.group.getParent().layout();
		}
	}
}